com.saxonica.expr

## Class IndexedFilterExpression

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - com.saxonica.expr.IndexedFilterExpression

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, ContextSwitchingExpression, InstructionInfo, Locator

      public final class IndexedFilterExpression
      extends Expression
      implements ContextSwitchingExpression

  An IndexedFilterExpression contains a base expression and a filter predicate. The base expression will always be a local variable reference. The filter will always be a Comparison, and it will have no positional dependencies
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IndexedFilterExpression(VariableReference start, ComparisonExpression filter, boolean indexFirstOperand)` Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `computeCardinality()` Get the static cardinality of this expression
    `int` | `computeDependencies()` Determine which aspects of the context the expression depends on.
    `int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
    `Expression` | `copy()` Copy an expression.
    `boolean` | `equals(Object other)` Is this expression the same as another expression?
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `VariableReference` | `getBaseExpression()` Get the underlying expression
    `Expression` | `getControlledExpression()` Get the subexpression that is evaluated in the new context
    `Expression` | `getControllingExpression()` Get the subexpression that sets the context item
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the IndexedFilter expression
    `ComparisonExpression` | `getFilter()` Get the filter expression
    `ItemType` | `getItemType(TypeHierarchy th)` Get the data type of the items returned
    `Expression` | `getSearchExpression()` Get the expression whose value we will be searching for
    `Expression` | `getUseExpression()` Get the expression to be indexed
    `int` | `hashCode()` get HashCode for comparing two expressions
    `SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Iterate over the results, returning them in the correct order
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `Expression` | `promote(PromotionOffer offer, Expression parent)` Promote this expression if possible
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, simplify, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### IndexedFilterExpression

          public IndexedFilterExpression(VariableReference start,
                                 ComparisonExpression filter,
                                 boolean indexFirstOperand)

      Constructor
      Parameters:
        `start` - Variable containing the sequence of items from which the selection will take place.
        `filter` - An expression defining the filter predicate
        `indexFirstOperand` - true if the first operand of the filter comparison is to be indexed, false if the second operand is to be indexed

  - ### Method Detail

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the data type of the items returned
      Specified by:
        `getItemType` in class `Expression`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        an integer representing the data type

    - #### getBaseExpression

          public VariableReference getBaseExpression()

      Get the underlying expression
      Returns:
        the expression being filtered

    - #### getFilter

          public ComparisonExpression getFilter()

      Get the filter expression
      Returns:
        the expression acting as the filter predicate

    - #### getControllingExpression

          public Expression getControllingExpression()

      Get the subexpression that sets the context item
      Specified by:
        `getControllingExpression` in interface `ContextSwitchingExpression`
      Returns:
        the subexpression that sets the context item, position, and size to each of its items in turn

    - #### getControlledExpression

          public Expression getControlledExpression()

      Get the subexpression that is evaluated in the new context
      Specified by:
        `getControlledExpression` in interface `ContextSwitchingExpression`
      Returns:
        the subexpression evaluated in the context set by the controlling expression

    - #### getUseExpression

          public Expression getUseExpression()

      Get the expression to be indexed
      Returns:
        the "use" expression, the expression that computes the index key for each item in the population

    - #### getSearchExpression

          public Expression getSearchExpression()

      Get the expression whose value we will be searching for
      Returns:
        the search expression

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Type-check the expression
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the expression after type-checking (potentially modified to add run-time checks and/or conversions)
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)

      Perform optimisation of an expression and its subexpressions.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### promote

          public Expression promote(PromotionOffer offer,
                           Expression parent)
                             throws XPathException

      Promote this expression if possible
      Overrides:
        `promote` in class `Expression`
      Parameters:
        `offer` - details of the promotion that is possible
        `parent` -
      Returns:
        the promoted expression (or the original expression, unchanged)
      Throws:
        `XPathException` - if any error is detected

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get the immediate subexpressions of this expression
      Overrides:
        `iterateSubExpressions` in class `Expression`
      Returns:
        the subexpressions, as an array

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressionInfo` in class `Expression`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `Expression`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### computeCardinality

          public int computeCardinality()

      Get the static cardinality of this expression
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the cardinality. The method attempts to determine the case where the filter predicate is guaranteed to select at most one item from the sequence being filtered

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-significant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        the static properties of the expression, as a bit-significant value

    - #### equals

          public boolean equals(Object other)

      Is this expression the same as another expression?
      Overrides:
        `equals` in class `Object`
      Parameters:
        `other` - the expression to be compared with this one
      Returns:
        true if the two expressions are statically equivalent

    - #### hashCode

          public int hashCode()

      get HashCode for comparing two expressions
      Overrides:
        `hashCode` in class `Object`
      Returns:
        the hash code

    - #### iterate

          public SequenceIterator<? extends Item> iterate(XPathContext context)
                                                   throws XPathException

      Iterate over the results, returning them in the correct order
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - the dynamic context for the evaluation
      Returns:
        an iterator over the expression results
      Throws:
        `XPathException` - if any dynamic error occurs

    - #### computeDependencies

          public int computeDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE
      Overrides:
        `computeDependencies` in class `Expression`
      Returns:
        the dependencies

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the IndexedFilter expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.